function [k_mean,pod_all,diag_S,eig_cum,eigen_cum_ratio, d] = burgers1d_k_mtraj_v2(Kmat_M,Ms)
% compute the POD basis from mean of Kmat_M

k_mean = mean(Kmat_M,3); % mean of the k matrice

%----- standard SVD to calculate POD

[nm,~] = size(Ms);
[n ,~] = size(k_mean);
dim    = 1;
rows   = 1:nm:n+1;

[R,~,S] = chol(Ms); % to define M^{1/2}

% for i=1:dim
%     u_snap(rows(i):rows(i+1)-1,:) = R*S'*u_snap(rows(i):rows(i+1)-1,:);
% end
% k_mean = u_snap*u_snap';
d      = rank(full(k_mean));
pod_all    = zeros(n, d);
fprintf(1,['Rank of data set is ',num2str(d),'\n']);

%----- calculate eigenvalue of K mean matrix
if d<size(k_mean,1)-1
    [V,Lambda] = eigs(k_mean,d);
else
    [V,Lambda] = eig(k_mean);
end
diag_S = sqrt(diag(Lambda(1:d, 1:d)));

%----- SVD algorithm to obtain POD
index=1;
while index~=0
    Num_change_index=nnz(diag_S - sort(diag_S,'descend')); % check if eigenvalues in descending order
    if Num_change_index==0
        index = 0;
    else
        fprintf(1,[num2str(index),' not in descending order\n']);
        index=index+1;
        [diag_S, Ind]=sort(diag_S,'descend');
        V = V(:, Ind);
        change_index=find(diag_S - sort(diag_S,'descend')~=0);
        if isempty(change_index)==0
            for i=1:2:Num_change_index % in this special case, wrong order always appears in couples
                temp_1 = change_index(i);
                temp_2 = change_index(i+1);
                temp_3 = diag_S(temp_2);         temp4       = V(:,temp_2);
                diag_S(temp_2) = diag_S(temp_1); V(:,temp_2) = V(:,temp_1);
                diag_S(temp_1) = temp_3;         V(:,temp_1) =temp4;
            end
        end
    end
end

%---- pod
for i=1:dim
    pod_all(rows(i):rows(i+1)-1,:) = S* (R\V(rows(i):rows(i+1)-1, 1:d));
end


%----- calculate eigenvalue decay
fprintf(1, 'Note Diag_S is sqrt{lambda}\n');
eig_cum = zeros(1,d);
for i=1:d
    eig_cum(i) = sum(diag_S(1:i).^2);
end
eigen_cum_ratio = eig_cum/sum(diag_S.^2);
if d>=8
    fprintf(1, 'The first 8 POD basis functions give the energy share as follows.\n');
    disp([(1:8)', eigen_cum_ratio(1:8)']);
    
end
