
% function plotEst_conv(File_estimator) % A_est_Mseq,B_est_Mseq)
% examine the convergence of A, B estimators 

%{
TODO: 
plot the convergence of the estimator 
%}

load(File_estimator); %,'A_est_Mseq','B_est_Mseq','M_seq');
[nx,nx,Nseq] = size(A_est_Mseq);

figpath = [filenames.Folder_save,'/Figures/']; 
if ~exist(figpath,'dir'), mkdir(figpath); end    

%% 1 an element 
figure; 
subplot(2,3,1);
ind = 1:1:M_seq(end);
plot(ind,squeeze(A_est_all(1,1,ind)),'linewidth',0.7); hold on; 
plot(ind,squeeze(B_est_all(1,1,1,ind)),'linewidth',0.7);
% xlabel('m'); 
title('(A) trajectory-wise estimator'); 
legend('$\widehat{A}$(1,1,m)','$\widehat{B}$(1,1,1,m)','Location','best','Interpreter','latex');
% figname = 'AB1entry';  set_positionFontsAll; 

% figure; % plot an element of A and B
subplot(2,3,2);
semilogx(M_seq,squeeze(A_est_Mseq(1,1,:)),'x-','linewidth',1); hold on; 
semilogx(M_seq,squeeze(B_est_Mseq(1,1,1,:)),'d-.','linewidth',1);
title('(B) M-trajectory estimator'); 
ylim([min(B_est_Mseq(1,1,1,:))*1.08,max(A_est_Mseq(1,1,:))*1.2]); 
% xlabel('M'); 
legend('$\widehat{A}_M$(1,1)','$\widehat{B}_M$(1,1,1)','Location','best','Interpreter','latex');
% figname = 'AB1entry_Mtraj';  set_positionFontsAll

%% 2 rate of convergence
A_end = A_est_Mseq(:,:,end); B_end = B_est_Mseq(:,:,:,end);
Aerr  = zeros(1,Nseq);       Berr  = zeros(1,Nseq);
for k= 1:Nseq-1
    Rt = A_est_Mseq(:,:,k); 
    Bt = B_est_Mseq(:,:,:,k);
    diffR = Rt - A_end;  Aerr (k) = norm(diffR)/(nx^2);
    diffB = Bt - B_end;  
    Berr (k) = sum(diffB.^2,'all')/(nx^3);
end
c1=M_seq(1)^(0.5)*Berr(1); 
rate_line =c1*M_seq.^(-0.5);
% figure; 
subplot(2,3,3);
loglog(M_seq,Aerr,'x-','linewidth',1); hold on;
loglog(M_seq,Berr,'d-.','linewidth',1);
loglog(M_seq,rate_line,'--','LineWidth',2,'Color',0.65*ones(3,1));
legend('Error $\widehat{A}_M$','Error $\widehat{B}_M$','slope -0.5','Interpreter','latex');
%        xlabel('M')
ylim([10^(-4),10^(-0.5)])
grid on;

if norm(c1seq(:,end))> 0
    diffc = c1seq(:,1:end)- c1seq(:,end);  
    cerr  = vecnorm(diffc)/length(c1seq(:,1));
    loglog(M_seq,cerr,'o--'); 
    legend('Error $\widehat{A}_M$','Error $\widehat{B}_M$','slope -0.5','Error $\widehat{c}_M$','Interpreter','latex');
end
title('(C) Convergence of estimator');
% figname = 'AB_Mtraj'; set_positionFontsAll


%%  Part II: Sigma 
%% 1 an element of Sigma
subplot(2,3,4); res_seq1 = sqrt(res_seq); 
ind = 1:1:M_seq(end);
semilogy(ind,sqrt(res_all(1,ind)),'linewidth',0.7); hold on; 
semilogy(ind,sqrt(res_all(end,ind)),'linewidth',0.7);
xlabel('m'); 
title('(D) trajectory-wise residual'); 
legend('$\Sigma$(1,1,m)','$\Sigma$(r,r,m)','Location','best','Interpreter','latex');
% figname = 'AB1entry';  set_positionFontsAll; 

% figure; % plot an element of A and B
subplot(2,3,5);
semilogx(M_seq,squeeze(res_seq1(1,:)),'x-','linewidth',1); hold on; 
semilogx(M_seq,squeeze(res_seq1(end,:)),'d-.','linewidth',1);
title('       (E) M-trajectory residual'); 
xlabel('M'); 
legend('$\Sigma_M$(1,1,m)','$\Sigma_M$(r,r,m)','Location','best','Interpreter','latex');
% figname = 'AB1entry_Mtraj';  set_positionFontsAll

%% 2 rate of convergence
Res_err  = zeros(1,Nseq);     
for k= 1:Nseq-1
    diffR = res_seq1(:,k) - res_seq1(:,end);  Res_err(k) = norm(diffR)/(nx);
end
c1=M_seq(1)^(0.5)*Res_err(1); 
rate_line =c1*M_seq.^(-0.5);
% figure; 
subplot(2,3,6);
loglog(M_seq,Res_err,'x-','linewidth',1); hold on; 
loglog(M_seq,rate_line,'--','LineWidth',2,'Color',0.65*ones(3,1));grid on;
legend('Error $\Sigma_M$','slope -0.5','Interpreter','latex','location','best');
xlabel('M'); ylim([10^(-5.01),10^(-3.5)])
set(gca,'ytick',[1e-5,1e-4]);
title('(F) Convergence of residual');
figname = 'Estimator_conv';
set_positionFontsAll

% end