function F = fem1d_load(x, e_conn, n_gauss, f, t, filename_shape)

%--------------------------------------------------------------------------
% The use of this subroutine is to generate load vector in FE
% discretization, (f, h)
% Written by Zhu Wang, Oct 18 2010
%--------------------------------------------------------------------------
[n_nodes,        dim] = size(x);
[n_elements, nel_dof] = size(e_conn);
[~,w] = fem1d_gauss_gen(n_gauss);
one   = ones(size(w));

load(filename_shape,'W_x_g','W_w_g','W_phi')

F   = zeros(n_nodes, 1);
for n_el= 1: n_elements
    nodes_local = e_conn(n_el, :);
    x_g   = W_x_g(:,(n_el-1)*dim+1:n_el*dim);
    w_g   = W_w_g(:,n_el);
    phi   = W_phi(:,(n_el-1)*nel_dof+1:n_el*nel_dof);
    
    fv1   = fem1d_fun_eval(f.func, f.var, x_g, t);
    f_loc = fem1d_bilinear(one, fv1.*one, phi, w_g );
    %  Assemble into the global system matrix
    F(nodes_local) = F(nodes_local) + f_loc;
end % n_el loop
