function filename_shape = fem1d_shape_gen(x,e_conn,n_gauss,File_save)
%--------------------------------------------------------------------------
% The use of this subroutine is for generating FE shape functions and store
% them in a mat file.
%--------------------------------------------------------------------------
%filename_shape = [File_save,'shapefunctions'];
filename_shape = File_save;

dim      = size(x , 2);
[n_elements, nel_dof] = size(e_conn);

if dim ==1
    W_x_g = sparse(n_gauss,n_elements*dim);
    W_w_g = sparse(n_gauss,n_elements);
    W_phi = sparse(n_gauss,n_elements*nel_dof);
    W_p_x = sparse(n_gauss,n_elements*nel_dof);
else
    error('N/A')
end
[r, w]   = fem1d_gauss_gen(n_gauss); % generate Gauss points
for n_el   = 1: n_elements
    nodes_local = e_conn(n_el,:);
    x_local     = x(nodes_local,:);
    [W_x_g(:,(n_el-1)*dim+1:n_el*dim),...
        W_w_g(:,n_el),...
        W_phi(:,(n_el-1)*nel_dof+1:n_el*nel_dof), ...
        W_p_x(:,(n_el-1)*nel_dof+1:n_el*nel_dof)] = ...
        fem1d_shape(x_local,r,w);
end

save(filename_shape,'W_x_g','W_w_g','W_phi','W_p_x')
