function SigmaT = Sigma_estimate_mtraj_v2(dX,dt)
% compute the diffusion matrix by quadractic variation from M traj
%         d X_t = f(X_t)dt + sigma dW_t
% with u_r(t) as X_t.
%    sigmaT = average ( <dXt, dX_t>/dt )


[nx,tN,M] = size(dX);
SigmaT = zeros(nx,nx); 
for m =1:M
    dX1      = dX(:,:,m);
    S_1traj  = dX1*dX1';
    SigmaT   = SigmaT+ S_1traj;
end
SigmaT = SigmaT/(M*tN)/dt; 

end