function [TildeA,TildeB] =burgers1d_dtsvd_invp_solver(U,S,V,b_rhs,r,choose_rank)
%-----------------------------------------
% A solver using decoupled truncated SVD
% to solve the Ax = b problem
% Output:
% TildeA rXr matrix
% TildeB rXrXr tensor
%-----------------------------------------
%---extract first j modes
Sa = S(1:choose_rank,1:choose_rank);
Ua = U(:,1:choose_rank);
Va = V(:,1:choose_rank);

eigen_Sr = diag(Sa);
S_diagi=1./eigen_Sr;
S_inv = diag(S_diagi);

%--- multiplying to the left
B_m = Va*S_inv*Ua'*b_rhs;

%---- assemble tildeA and tildeB
TildeA = B_m(1:r,:)';
TildeB = B_m(r+1:end,:);
TildeB= reshape(TildeB,r,r,r);

end