function [matrix_e] = burgers1d_tsvd_lhs_mat(a_snap)
%------------------------------------------
% Assemble the matrix E in the DD-VMS-ROM
% Intends for the standard truncated SVD (TSVD)
% a_snap is the matrix of size M*r
% output is E matrix of size MrX(r^2+r^3)
%------------------------------------------

[r,M] = size(a_snap);

C = speye(r);

II = zeros(M*r*(r^2+r),1);
JJ = zeros(M*r*(r^2+r),1);
SS = zeros(M*r*(r^2+r),1);

nonsize = r*(r^2+r);

for j = 1:M
    aj = a_snap(:,j);
    A1 = aj';
    count = r*(r^2+r)*(j-1);
    
    B1 = aj*aj';
    B1 = reshape(B1,[],1)';
    temp1 = kron(C,A1); % size: r*r^3
    temp2 = kron(C,B1); % size r*r^3
    E_j =[temp1,temp2];
    [Ij,Jj,Sj] =find(E_j);
    II(count+(1:nonsize)) = Ij+r*(j-1);
    JJ(count+(1:nonsize)) = Jj;
    SS(count+(1:nonsize)) = Sj;
end

matrix_e = sparse(II,JJ,SS,M*r,r^2+r^3);

% matrix_e = zeros(M,r+r^2);
%
% for j =1:M
%
%     aj = a_snap(:,j);
%     A1 = aj';
%
%     B1 = aj*aj';
%     B1 = reshape(B1,[],1)';
%
%     matrix_e(j,:) = [A1,B1];
%
% end



return;