function [TildeA, TildeB,rhs_vec_reg,lhs_mat_reg] = burgers1d_two_scale_quadratic_ansatz_reg_gen(opt,domain,fem_settings,...
    filenames,Mr,Sr,...
    tensor_r,tensor_d,a_snap_r,a_snap_d)
%------------------------------------------
% Assemble LHS and RHS of the least square problem in DD-VMS-ROM
% Intends for the standard truncated SVD (TSVD)
%
% Output:
% rhs_mat is tau of size MrX1
% lhs_mat is E matrix of size MrX(r^2+r^3)
%------------------------------------------
[rhs_vec, lhs_mat] = burgers1d_two_scale_quadratic_ansatz_tsvd_gen(tensor_r,tensor_d,a_snap_r,a_snap_d);


rhs_vec_reg = lhs_mat'*rhs_vec;
lhs_mat_reg = lhs_mat'*lhs_mat;

u0 = a_snap_r(:,1);

r = size(u0,1);

[TildeA, TildeB]= burgers1d_2s_rom_normal_1traj(opt,domain,fem_settings,...
    filenames,Mr,Sr,...
    u0,r, lhs_mat_reg, rhs_vec_reg,tensor_d,a_snap_d);

end