function Frk4 = rk4_ROM_AB(xt,A,B,dt)
% One-step integration of the deterministic truncated system with 2*K1 modes
%            dX = (AX + X'*B*X)
% X(t+1) = X(t) + dt* Frk4; 

[nx,tN] = size(xt);          
Frk4    = zeros(nx,tN); 
% A       = romInfo.A; B       = romInfo.B;  dt      = romInfo.dt;
rhsFn = @(X) A*X + computeBterm(B,X);

for t = 1:tN
    x1 = xt(:,t); 
    k1 = rhsFn(x1 ); 
	k2 = rhsFn(x1 + dt*k1/2 );
	k3 = rhsFn(x1 + dt*k2/2 );
	k4 = rhsFn(x1 + dt*k3 );
    Frk4(:,t) = ( k1 + 2*k2 + 2*k3 + k4 ) / 6;
end

return