%% set position, size of figure; and set fonts
%  function set_positionFontsAll(nrow,ncol)
% ftsz = 20; mksz = 10; % if save to -dpdf
ftsz =10; mksz =10; % if save to -depsc
set(findall(gcf,'-property','FontSize'),'FontSize',ftsz);
set(findall(gcf,'-property','MarkerSize'),'MarkerSize',mksz);
% tightfig;


%% get the number of subplots in gcf; 
cells_axes = findobj(gcf,'type','axes');
N = length(cells_axes);
pos1 = zeros(N,1); pos2 = zeros(N,1);
for n = 1:N
    pos1(n) = cells_axes(n).Position(1);
    pos2(n) = cells_axes(n).Position(2);
end
Ncols = numel(unique(pos1));
Nrows = numel(unique(pos2));

%% set figure size
% width = 540+270*(Ncols-1); height = 240+120*(Nrows-1);   % 9:4
width = 400+200*(Ncols-1); height = 310+120*(Nrows-1);   % 9:4

set(gcf, 'Position',  [100, 1000, width, height]);    % set figure position + size [x , x, width height]
% tightfig;
h = axes(fig,'visible','off'); 
c = colorbar(h,'Position',[0.93 0.168 0.022 0.7]);  % attach colorbar to h % colormap(c,'jet')
caxis(h,[0,0.82]); 

if exist('figpath', 'var') && exist('figname', 'var')
    print([figpath,figname,'.pdf'],'-dpdf', '-bestfit');
 %    print([figpath,figname,'.eps'],'-depsc');
end
if (~exist('figpath', 'var')) && exist('figname', 'var')
    print([figname,'.pdf'],'-dpdf', '-fillpage');  
end