%% get estimator for a sequence of timegaps. Saved in filename

function [File_estimator,romInfo_seq,gapSeq] = getEst_timegapSeq(gapSeq,a_Mtraj,dt,anastz_type,pod_all1,viscosity,r,x_mesh,filenames)
% gapSeq         = 1:1:15; 
% anastz_type    = 'Afull_Bsym';  % select from  Afull_Bsym , rk4_AB, Adiag_Bsym, NAR
n_gapSeq   = length(gapSeq);
[nx,tN,M]  = size(a_Mtraj); 
File_estimator  = [filenames.Folder_save,sprintf('spaceTime_Est_M%i_r%i_timegap%ito%i_',M,r,gapSeq(1),gapSeq(end)),anastz_type,'.mat'];
   
if ~exist(File_estimator,'file')    
%     A_est_gapseq = zeros(nx,nx,n_gapSeq);
%     B_est_gapseq = zeros(nx,nx,nx,n_gapSeq);
%     res_gapseq   = zeros(nx,n_gapSeq);  c_est_gapseq = zeros(nx,n_gapSeq);
    romInfo_seq  = cell(1,n_gapSeq); 
    for i=1:n_gapSeq
        fprintf('r = %i, Time gap = %i\n', r,i);
        timegap = gapSeq(i); a_Mtraj_1 = a_Mtraj(:,1:timegap:end,:);
        delta   = timegap*dt;
        
        [romInfo1,A,B]   = get_ROM_info(pod_all1,delta,viscosity,r,x_mesh,anastz_type);    % eig(A);   %  we need all eigenvalues to be negative, and to decay fast
        romInfo1.timegap = timegap;
        romInfo1        = est_conv_mtraj_v2(a_Mtraj_1,delta, romInfo1,File_estimator,0);        % get the estimators and save them
%         A_est_gapseq(:,:,i)    = romInfo1.A_est;
%         B_est_gapseq(:,:,:,i)  = romInfo1.B_est;
%         c_est_gapseq(:,i)      = romInfo1.c_est;
%         res_gapseq(:,i)        = romInfo1.res;
        romInfo_seq{i}        = romInfo1; 
    end
    save(File_estimator,'romInfo_seq','gapSeq'); %,'A_est_gapseq','B_est_gapseq','res_gapseq','romInfo_seq','c_est_gapseq','gapSeq');
else 
    load(File_estimator,'romInfo_seq','gapSeq'); % 'A_est_gapseq','B_est_gapseq','res_gapseq','romInfo_seq','c_est_gapseq','gapSeq');
end


end


